//+------------------------------------------------------------------+
//|                                                  TSatr_NRTR_Last |
//|                                Copyright  2004, OlegVS&Aborigen |
//|                                             olegvs2003@yahoo.com |
//|                                     (translated to MQL4 by uran) |
//|                                                                  |
//| 23.11.2005       by KimIV.    |
//|         start:             |
//|   if (UseTrailing) TrailingPositions();                          |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

//-------    -----------------------------------
extern string _Parameters_Trailing = "-----  ";
extern bool   UseTrailing = True;   //  
extern int    Patr        = 9;
extern int    Prange      = 5;
extern double Kstop       = 0.5;
extern double kts         = 2.0;
extern double Vts         = 2.0;
/* 
      ,  
    Vts.   Vts=1 
   ,     ,    
  ATR   (     ).
    Vts=2      
     ( )   
  (  Prange=5).    
          
      .    
     15-25%   .
*/ 

//+------------------------------------------------------------------+
void TrailingPositions() {
  static int prevBars;
  int cnt, I, total;
  double ValATR, hi, lo, SL, TS;
  if (prevBars!=Bars) {
    ValATR=0;
    for (I=0; I<Patr; I++) {
      if (I<=Patr) ValATR+=High[I]-Low[I];
    }
    ValATR=NormalizeDouble(ValATR/Patr, 4);

    hi=High[Highest(NULL,0,MODE_HIGH,Prange,Prange)]; 
    lo=Low [Lowest (NULL,0,MODE_LOW ,Prange,Prange)]; 

    if (Vts==1) TS=kts*ValATR;
    SL=Kstop*ValATR;
    if (Vts==2) TS=(hi-lo);
    SL=Kstop*(hi-lo);

    prevBars=Bars;
  }
  if (Vts<1 || Vts>2) return;

  //------------------------------------------------------- 
  total=OrdersTotal();
  for (cnt=0; cnt<total; cnt++) {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {

      // First Stop ---------------------------------
      if (OrderType()==OP_BUY && OrderStopLoss()==0) {
        OrderModify(OrderTicket(),OrderOpenPrice(),Low[0]-SL,OrderTakeProfit(),0,clModifyBuy);
        return;
      }

      if (OrderType()==OP_SELL && OrderStopLoss()==0) {
        OrderModify(OrderTicket(),OrderOpenPrice(),High[0]+SL,OrderTakeProfit(),0,clModifySell);
        return;
      }

      // Main Trailing ------------------------------- 
      if (OrderType()==OP_BUY && High[0]-OrderOpenPrice()>TS
      && (OrderStopLoss()<High[0]-TS || OrderStopLoss()==0)) {
        OrderModify(OrderTicket(),OrderOpenPrice(),High[0]-TS,OrderTakeProfit(),0,clModifyBuy);   
        return;
      }

      if (OrderType()==OP_SELL && OrderOpenPrice()-Low[0]>TS
      && (OrderStopLoss()>Low[0]+TS || OrderStopLoss()==0)) {
        OrderModify(OrderTicket(),OrderOpenPrice(),Low[0]+TS,OrderTakeProfit(),0,clModifySell);   
        return;
      }
    }
  }
}
//+------------------------------------------------------------------+

